=== debian/changelog ===
opencv (2.4.9.1+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches:
    - Add fix_ftbfs_with_gcc6 to fix FTBFS with gcc-6. (Closes: #828928)

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Tue, 04 Oct 2016 17:07:49 +0200

opencv (2.4.9.1+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Use HTTPS in Vcs-* fields.
  * Disable opengl when building in armhf (in Ubuntu only)
  * Don't build with jasper.  Closes: #818207
    This causes libopencv-highgui to lose symbols, so we need to rename the
    package and do a transition.
  * Fix typo in README.Debian.
  * Remove unused lintian override python-script-but-no-python-dep.
  * Add missing dependency on libopencv-gpu2.4v5 to libopencv-gpu-dev.
    Closes: #825583

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 27 Jun 2016 05:08:42 +0000
